; simple tests of the procedures written for hw3

(load "hw3.scm")
(load "rat-operators.scm")

(define (identity x) x)
(define (inc x) (+ x 1))
(define (square x) (* x x))
(define (cube x) (* x x x))

(define (test-it s t)
  (display s)
  (display " => ")
  (display t)
  (eval s))

(test-it '(make-rat 1 2) '(1 2))
(test-it '(make-rat -1 -2) '(1 2))
(test-it '(make-rat -1 2) '(-1 2))
(test-it '(make-rat 1 -2) '(-1 2))
(test-it '(make-rat 2 4) '(1 2))
(test-it '(add-rat (make-rat 1 2) (make-rat 3 2)) '(2 1))

(test-it '(count-down-from 1) '(1))
(test-it '(count-down-from 5) '(5 4 3 2 1))
(test-it '(count-up-to 1) '(1))
(test-it '(count-up-to 5) '(1 2 3 4 5))

(test-it '(add-transformed (list 0 1 2 3 4 5 6 7) identity) 28)
(test-it '(add-transformed (list 0 1 2 3 4 5 6 7) (lambda (x) (expt 2 x))) 255)

(test-it '(delete 1 (list 1)) '())
(test-it '(delete 1 (list 1 1 1)) '())
(test-it '(delete 1 (list 1 2 3)) '(2 3))
(test-it '(delete 1 (list 2 3 4)) '(2 3 4))
(test-it '(delete 1 (list 3 2 1)) '(3 2))

; 5 and 6 you'll have to test for yourself.  

(test-it '(present? 1 (list 3 2 1)) #t)
(test-it '(present? 1 (list 3 (list 2 1) 0)) #t)
(test-it '(present? 1 (list 3 2)) #f)
(test-it '(present? 1 (list 3 (list 2) 0)) #f)
(test-it '(present? 'a '(c b a)) #t)
(test-it '(present? 'a '(c (b a) z)) #t)
(test-it '(present? 'a '(c b)) #f)
(test-it '(present? 'a '(c (b) z)) #f)

(test-it '(total-weight (make-mobile (make-branch 2 3) (make-branch 6 1))) 4)
(test-it '(total-weight (make-mobile 
               (make-branch 2 (make-mobile (make-branch 15 1) (make-branch 5 3)))
               (make-branch 8 1))) 5)
(test-it '(total-weight (make-mobile 
               (make-branch 20 (make-mobile (make-branch 15 1) (make-branch 5 3)))
               (make-branch 10 (make-mobile (make-branch 3 2) (make-branch 1 6))))) 12)

(test-it '(balanced? (make-mobile (make-branch 2 3) (make-branch 6 1))) #t)
(test-it '(balanced? (make-mobile 
               (make-branch 2 (make-mobile (make-branch 15 1) (make-branch 5 3)))
               (make-branch 8 1))) #t)
(test-it '(balanced? (make-mobile 
               (make-branch 20 (make-mobile (make-branch 15 1) (make-branch 5 3)))
               (make-branch 10 (make-mobile (make-branch 3 2) (make-branch 1 6))))) #t)

(test-it '(balanced? (make-mobile 
               (make-branch 20 (make-mobile (make-branch 15 1) (make-branch 5 3)))
               (make-branch 10 (make-mobile (make-branch 3 2) (make-branch 1 5))))) #f)

(test-it '(apply-all 2) '())
(test-it '(apply-all 2 identity square cube) '(2 4 8))
(test-it '(apply-all 2 (lambda (x) (expt 2 x))) '(4))
